stages:
  - build
  - test
  - deploy # dummy stage to follow the template guidelines
  - review
  - dast
  - staging
  - canary
  - production
  - incremental rollout 10%
  - incremental rollout 25%
  - incremental rollout 50%
  - incremental rollout 100%
  - performance
  - cleanup

include:
  - project: "opencity-labs/product"
    ref: "main"
    file: ".gitlab/ci/devops.yml"

unittest:
  stage: test
  image: tiangolo/uvicorn-gunicorn:python3.11
  services:
    - name: docker.redpanda.com/redpandadata/redpanda:v23.2.19
      alias: kafka
      command:
        - redpanda
        - start
        - --kafka-addr internal://0.0.0.0:9092,external://0.0.0.0:19092
        - --advertise-kafka-addr internal://kafka:9092,external://localhost:19092
        - --pandaproxy-addr internal://0.0.0.0:8082,external://0.0.0.0:18082
        - --advertise-pandaproxy-addr internal://kafka:8082,external://localhost:18082
        - --smp 1
        - --memory 1G
        - --mode dev-container
        - --set redpanda.auto_create_topics_enabled=true

    - name: mcr.microsoft.com/azure-storage/azurite
      alias: azurite
      variables:
        AZURITE_ACCOUNTS: admin:Eby8vdM02xNOcqFlqUwJPLlmEtlCDXJ1OUzFT50uSRZ6IFsuFq2UVErCz4I6tq==
        AZURITE_BLOB_HOST: 0.0.0.0
        AZURITE_BLOB_PORT: 10000
        AZURITE_LOCATION: /ddata/protocollo

    - name: minio/minio
      alias: minio
      command:
        - "server"
        - "/data"
        - "--console-address"
        - ":9001"

      variables:
        MINIO_ROOT_USER: "Test_key_innonation"
        MINIO_ROOT_PASSWORD: "innonation"
        MINIO_BUCKET: "protocollo"

  variables:
    STORAGE_ACCESS_S3_KEY: "Test_key_innonation"
    STORAGE_KEY_S3_ACCESS_SECRET: "innonation"
    STORAGE_BUCKET: "protocollo"
    STORAGE_S3_REGION: "us-east-1"
    KAFKA_TOPIC_NAME: "documents"
    KAFKA_BOOTSTRAP_SERVERS: "kafka:9092"
    STORAGE_TYPE: "local"

  before_script:
    # Copy and execute the setup script
    - cp setup_env_test.sh /tmp/setup_env_test.sh
    - chmod +x /tmp/setup_env_test.sh
    - /tmp/setup_env_test.sh

  script:
    - source venv/bin/activate
    - cd protocol_proxy
    - PYTHONPATH=. pytest --disable-warnings --maxfail=1 -v

  after_script:
    - echo "Tests completed"
